#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/errno.h>
#include <sysexits.h>
#include <mach/mach.h>
#include <mach/mach_error.h>
#include <IOKit/IOKitLib.h>
#include <IOKit/IOCFPlugIn.h>
#include <IOKit/hid/IOHIDLib.h>
#include <IOKit/hid/IOHIDKeys.h>
#include <CoreFoundation/CoreFoundation.h>
#include <Carbon/Carbon.h>

#import <Cocoa/Cocoa.h>

/*
 Använder element
 In till datorn.
 2: digital in
 3: vet inte läser en etta för det mesta
 4:analog in 1
 5: analog in 2
 6: räkneverk 1
 7: räkneverk 1 x256
 8: räkneverk 2
 9: räkneverk 2 x256
 Ut till kortet:
 10: 1 för att skriva minitid på räknare 1, 2 för räknare 2, 3 nollställer räkneverk 1, 4 nollställer räkneverk 2, 5 gör att det går at skriva till analoga och digitala ingångar.
 11: digital ut
 12: analog ut 1
 13: analog ut 2
 16: minitid för att räknare 1 ska räkna något som ett tryck
 17: minitid för att räknare 2 ska räkna något som ett tryck
 14-17: vet inte
 */


@interface K8055KortKomHID : NSObject {
    IOHIDDeviceInterface **hidDeviceInterface;
    int digitalUt;
}
- (void) nollaRaknare:(int)vilken; //(0 eller 1)
- (void)startaDigitalUt:(int)utgang; // Utgång 0-7
- (void)stoppaDigitalUt:(int)utgang; // Utgång 0-7
- (void) setAnalogUt:(int)utgang till:(int)varde;//utgang 1 eller 2 värde 0-255
- (void) nollaAllt;
- (BOOL)digitalIn:(int)ingang; // 1-5
- (int)analogIn:(int)ingang; // 0-1
- (int)raknare:(int)raknis; //0-1
- (void)setMinitid:(double)sek paRaknare:(int)raknis;
    
@end
