#import "K8055KortKomHID.h"


@implementation K8055KortKomHID
- (void) nollaRaknare:(int)vilken { //(0 eller 1)
    IOHIDEventStruct hidEvent;
    int vilkenN = 0!=vilken;
    hidEvent.value=3+vilkenN;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
    // ppna fr vrig skrivning igen
    hidEvent.value=5;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
}  
-(void)startaDigitalUt:(int)utgang{ // Utgng 0-7
    int tUt = 1 << utgang;
    // NSLog(@"starta:%i %i",utgang,tUt);
    IOHIDEventStruct hidEvent;
    digitalUt = digitalUt|tUt;
    hidEvent.value = digitalUt;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)11, &hidEvent, nil,nil,nil,nil);
}   
-(void)stoppaDigitalUt:(int)utgang{ // Utgng 0-7
    int tUt = 1 << utgang;
    IOHIDEventStruct hidEvent;
    digitalUt = (digitalUt|tUt) - tUt;
    hidEvent.value = digitalUt;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)11, &hidEvent, nil,nil,nil,nil);
}   
- (void) setAnalogUt:(int)utgang till:(int)varde { //utgang 1 eller 2 vrde 0-255
    IOHIDElementCookie tUt = (IOHIDElementCookie)(12+(0!=utgang));
    IOHIDEventStruct hidEvent;
    int tV = varde>255? 255:varde;
    tV = tV<0? 0:tV;
    hidEvent.value = 5;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = tV;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)tUt, &hidEvent, nil,nil,nil,nil);
}   

-(void) nollaAllt {
    [self nollaRaknare:0];
    [self nollaRaknare:1];
    digitalUt = 0;
    IOHIDEventStruct hidEvent;
    hidEvent.value = digitalUt;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)11, &hidEvent, nil,nil,nil,nil);
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)12, &hidEvent, nil,nil,nil,nil);
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)13, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = 1;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = 4;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)16, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = 2;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = 4;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)17, &hidEvent, nil,nil,nil,nil);
}
//(*hidDeviceInterface)->Release(hidDeviceInterface);
-(BOOL)digitalIn:(int)ingang { // 0-4
    int tIn = 0;
    if (ingang <= 0) tIn = 16;
    else if (ingang == 1) tIn = 32;
    else if (ingang == 2) tIn = 1;
    else if (ingang == 3) tIn = 64;
    else  tIn = 128;
    IOHIDEventStruct hidEvent;
    (*hidDeviceInterface)->getElementValue(hidDeviceInterface, (IOHIDElementCookie)2, &hidEvent); 
    if (hidEvent.value&tIn) return true;
    else return false;
}

-(int)analogIn:(int)ingang { // 0-1
    IOHIDElementCookie tIn = (IOHIDElementCookie)(4+(0!=ingang));
    IOHIDEventStruct hidEvent;
    (*hidDeviceInterface)->getElementValue(hidDeviceInterface, (IOHIDElementCookie)tIn, &hidEvent); 
    int raknaIn = hidEvent.value;
    return raknaIn/1;
}
- (int)raknare:(int)raknis {
    IOHIDElementCookie tIn = (IOHIDElementCookie)(6+2*(0!=raknis));
    IOHIDEventStruct hidEvent;
    (*hidDeviceInterface)->getElementValue(hidDeviceInterface, (IOHIDElementCookie)tIn, &hidEvent);
    int total = hidEvent.value;
    (*hidDeviceInterface)->getElementValue(hidDeviceInterface, (IOHIDElementCookie)(tIn+1), &hidEvent);
    total = total+256*hidEvent.value;
    return total;
}
- (void)setMinitid:(double)sek paRaknare:(int)raknis {
    int raknare = (0!=raknis);
    IOHIDEventStruct hidEvent;
    hidEvent.value = 1+raknis;
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)10, &hidEvent, nil,nil,nil,nil);
    hidEvent.value = (int)sqrt(sek*9040); // Visste inte hur jag skulle f fram exakt siffra hr
    (*hidDeviceInterface)->setElementValue(hidDeviceInterface, (IOHIDElementCookie)(16+raknare), &hidEvent, nil,nil,nil,nil);
}

- (void)dealloc {
    (*hidDeviceInterface)->close(hidDeviceInterface);
    (*hidDeviceInterface)->Release(hidDeviceInterface);
    [super dealloc];
}


- (id) init
{
    [super init];
    NSLog(@"K8055KortKom initierar");
    digitalUt = 0;
    mach_port_t masterPort = NULL;
    io_iterator_t hidObjectIterator = NULL;
    IOReturn result = kIOReturnSuccess;
    result = IOMasterPort(bootstrap_port, &masterPort);
    CFMutableDictionaryRef hidMatchDictionary = NULL;
    Boolean noMatchingDevices = false;
    hidMatchDictionary = IOServiceMatching(kIOHIDDeviceKey); //("IOUSBDevice");
    SInt32 vendorID = 4303;
    CFDictionarySetValue( hidMatchDictionary, CFSTR("idVendor"), CFNumberCreate(kCFAllocatorDefault, kCFNumberSInt32Type, &vendorID)); 
    result = IOServiceGetMatchingServices(masterPort, hidMatchDictionary, &hidObjectIterator);
    noMatchingDevices = ((result != kIOReturnSuccess) | (hidObjectIterator == NULL));
    if (noMatchingDevices) printf("No matching HID class devices found.", result);
    hidMatchDictionary = NULL;
    
    if (hidObjectIterator != NULL)
    {
	io_object_t hidDevice = NULL;
	hidDeviceInterface = NULL;
	while ((hidDevice = IOIteratorNext(hidObjectIterator)))
	{
	    CFMutableDictionaryRef properties = 0;
	    char path[512];
	    result = IORegistryEntryCreateCFProperties(hidDevice, &properties, kCFAllocatorDefault, kNilOptions);
	    if ((result == KERN_SUCCESS) && properties)
	    {
		NSString *transport = [(NSDictionary *)properties objectForKey:@"Product"];
		if (![transport isEqual:@"USB K8055"]) continue;
		printf("Hittade USB K8055\n");
		printf([[(id)properties description] cString]);
		CFRelease(properties);
	    }
	    
	    io_name_t className;
	    IOCFPlugInInterface **plugInInterface = NULL;
	    SInt32 score = 0;
	    result = IOObjectGetClass(hidDevice, className);
	    result = IOCreatePlugInInterfaceForService(hidDevice, kIOHIDDeviceUserClientTypeID, kIOCFPlugInInterfaceID,  &plugInInterface, &score);
	    if (result == kIOReturnSuccess)
	    {
		result = (*plugInInterface)->QueryInterface(plugInInterface, CFUUIDGetUUIDBytes(kIOHIDDeviceInterfaceID), (LPVOID) &hidDeviceInterface);
	    } else {
		printf("Couldnt create HID class device interface");
		(*plugInInterface)->Release(plugInInterface);
	    }
	     
	    result = IOObjectRelease(hidDevice);
	    if (hidDeviceInterface != NULL)
	    {
		result = (*hidDeviceInterface)->open(hidDeviceInterface, 0);
		if (result) printf("Open result = %lx\n", result);
		int result;
		//Nollstll
		[self nollaAllt];
	    }
	}
	IOObjectRelease(hidObjectIterator);
    }
    if (masterPort) mach_port_deallocate(mach_task_self(), masterPort); 
    NSLog(@"K8055KortKom initierat klart");
    return self;
}
@end
